/*
This file is part of Noob-a-Tron.

Copyright Jeff Mitchell 2016

Noob-a-Tron is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Noob-a-Tron is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Noob-a-Tron.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "input.h"

void Input::init() {
Uint8* keyboard = (Uint8*)SDL_GetKeyboardState(&numKeys);
keys = new bool[numKeys];
prevKeys = new bool[numKeys];
  for(int i = 0; i < numKeys; i++)
  {
  keys[i] = keyboard[i];
  prevKeys[i] = false;
  }
}

void Input::kill() {
delete[] keys;
delete[] prevKeys;
}

void Input::update() {
Uint8* keyboard = (Uint8*)SDL_GetKeyboardState(&numKeys);
  for(int i = 0; i < numKeys; i++)
  {
  prevKeys[i] = keys[i];
  keys[i] = keyboard[i];
  }
}

bool Input::keyDown(int key) {
if(key < 0 || key > numKeys) return false;
return keys[key];
}

bool Input::keyHit(int key) {
if(key < 0 || key > numKeys) return false;
return (keys[key] && !prevKeys[key]);
}

bool Input::keyUp(int key) {
if(key < 0 || key > numKeys) return false;
return (prevKeys[key] && !keys[key]);
}
