/*
This file is part of Noob-a-Tron.

Copyright Jeff Mitchell 2016

Noob-a-Tron is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Noob-a-Tron is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Noob-a-Tron.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "graphics.h"
#include "input.h"
#include "thing.h"
#include <SDL2/SDL.h>
#include <iostream>
#include <list>

std::list<Plastic> BombList;
Graphics g;
SDL_Surface* GetBackbuffer();
Graphics GetGraphicsObj();
SDL_Surface* GetBMPplastic();

int main(int argc, char *argv[]) {

g.init();
Input input;
input.init();
SDL_Rect area;
area.x = 50;
area.y = 50;

long int frameTime;
frameTime = SDL_GetTicks();
long int frameStart;
frameStart = 0;

bool done = false;
while (!done)
{
  SDL_Event event;
  while (SDL_PollEvent(&event)) {
  if (event.type == SDL_KEYDOWN && event.key.keysym.sym == SDLK_ESCAPE) {
  done = true;
  break; }
  }

frameStart = SDL_GetTicks();
input.update();

frameTime = SDL_GetTicks() - frameStart;
g.kleenScreen();


if (input.keyDown(SDL_SCANCODE_UP)) area.y-=4;
if (input.keyDown(SDL_SCANCODE_RIGHT)) area.x+=4;
if (input.keyDown(SDL_SCANCODE_DOWN)) area.y+=4;
if (input.keyDown(SDL_SCANCODE_LEFT)) area.x-=4;
if (input.keyHit(SDL_SCANCODE_SPACE)) BombList.push_back(Plastic(area.x, area.y));
SDL_BlitSurface(g.specialopsBMP, 0, g.backbuffer, &area);

for (Plastic& BombObj : BombList) {
BombObj.KeepChecking();
}

g.flip();
if (frameTime < 60) SDL_Delay(1);
}

input.kill();
g.stop();
return 0; }

SDL_Surface* GetBackbuffer() {
return g.backbuffer;
}

Graphics GetGraphicsObj() {
return g;
}

SDL_Surface* GetBMPplastic() {
return g.plasticBMP;
}
