/*
This file is part of Noob-a-Tron.

Copyright Jeff Mitchell 2016

Noob-a-Tron is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Noob-a-Tron is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Noob-a-Tron.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "thing.h"
#ifndef GRAPHICS_H_INCLUDED
#define GRAPHICS_H_INCLUDED
#include "graphics.h"
#endif

#include <iostream>
#include <SDL2/SDL.h>

SDL_Surface* GetBackbuffer();
Graphics GetGraphicsObj();
SDL_Surface* GetBMPplastic();

void Thing::drawMe(SDL_Surface *img, SDL_Surface *vid, SDL_Rect area) {
SDL_BlitSurface(img, 0, vid, &area);
};

Player::Player(int a, int b) {
location.x = a;
location.y = b;
};

Plastic::Plastic(int a, int b) {
location.x = a;
location.y = b;
OldSeconds = SDL_GetTicks();
seconds = 5000;
};

Plastic::~Plastic()
{}

void Plastic::KeepChecking() {
if (seconds > 5) BombFunctions();
}

void Plastic::BombFunctions() {
seconds = seconds - 4;
  if (seconds >= 4000)
  DrawImageFrame(GetBMPplastic(), GetBackbuffer(), location.x, location.y, 4);
  else if (seconds < 4000 && seconds >= 3000)
  DrawImageFrame(GetBMPplastic(), GetBackbuffer(), location.x, location.y, 3);
  else if (seconds < 3000 && seconds >= 2000)
  DrawImageFrame(GetBMPplastic(), GetBackbuffer(), location.x, location.y, 2);
  else if (seconds < 2000 && seconds >= 1000)
  DrawImageFrame(GetBMPplastic(), GetBackbuffer(), location.x, location.y, 1);
  else if (seconds < 1000 && seconds >= 10)
  DrawImageFrame(GetBMPplastic(), GetBackbuffer(), location.x, location.y, 0);
}

void Plastic::DrawImageFrame(SDL_Surface* image, SDL_Surface* destSurface, int x, int y, int frame)
{
SDL_Rect destRect;
destRect.x = x;
destRect.y = y;
SDL_Rect sourceRect;
sourceRect.y = 0;
  if (frame == 4)
  sourceRect.x = 0;
  else if (frame == 3)
  sourceRect.x = 80;
  else if (frame == 2)
  sourceRect.x = 160;
  else if (frame == 1)
  sourceRect.x = 240;
  else if (frame == 0)
  sourceRect.x = 320;
sourceRect.w = 80;
sourceRect.h = 80;
SDL_BlitSurface(image, &sourceRect, destSurface, &destRect);
}
